package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.ArrayList;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.ASTNode;
import org.eclipse.jdt.internal.compiler.ast.AbstractMethodDeclaration;
import org.eclipse.jdt.internal.compiler.ast.Assignment;
import org.eclipse.jdt.internal.compiler.ast.ConditionalExpression;
import org.eclipse.jdt.internal.compiler.ast.ExpressionContext;
import org.eclipse.jdt.internal.compiler.ast.FieldReference;
import org.eclipse.jdt.internal.compiler.ast.MessageSend;
import org.eclipse.jdt.internal.compiler.ast.NameReference;
import org.eclipse.jdt.internal.compiler.ast.QualifiedNameReference;
import org.eclipse.jdt.internal.compiler.ast.SingleNameReference;
import org.eclipse.jdt.internal.compiler.ast.Statement;
import org.eclipse.jdt.internal.compiler.ast.TypeDeclaration;
import org.eclipse.jdt.internal.compiler.codegen.BranchLabel;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.flow.FlowContext;
import org.eclipse.jdt.internal.compiler.flow.FlowInfo;
import org.eclipse.jdt.internal.compiler.impl.Constant;
import org.eclipse.jdt.internal.compiler.impl.ReferenceContext;
import org.eclipse.jdt.internal.compiler.lookup.ArrayBinding;
import org.eclipse.jdt.internal.compiler.lookup.BaseTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.ClassScope;
import org.eclipse.jdt.internal.compiler.lookup.FieldBinding;
import org.eclipse.jdt.internal.compiler.lookup.InferenceContext18;
import org.eclipse.jdt.internal.compiler.lookup.LocalVariableBinding;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeVariableBinding;
import org.eclipse.jdt.internal.compiler.lookup.VariableBinding;
import org.eclipse.jdt.internal.compiler.lookup.WildcardBinding;
import org.eclipse.jdt.internal.compiler.problem.ShouldNotImplement;
import org.eclipse.jdt.internal.compiler.util.Messages;

public abstract class Expression extends Statement {
  public Constant constant;
  
  public int statementEnd = -1;
  
  public int implicitConversion;
  
  public TypeBinding resolvedType;
  
  public static org.eclipse.jdt.internal.compiler.ast.Expression[] NO_EXPRESSIONS = new org.eclipse.jdt.internal.compiler.ast.Expression[0];
  
  public static final boolean isConstantValueRepresentable(Constant constant, int constantTypeID, int targetTypeID) {
    if (targetTypeID == constantTypeID)
      return true; 
    switch (targetTypeID) {
      case 2:
        switch (constantTypeID) {
          case 2:
            return true;
          case 8:
            return (constant.doubleValue() == constant.charValue());
          case 9:
            return (constant.floatValue() == constant.charValue());
          case 10:
            return (constant.intValue() == constant.charValue());
          case 4:
            return (constant.shortValue() == constant.charValue());
          case 3:
            return (constant.byteValue() == constant.charValue());
          case 7:
            return (constant.longValue() == constant.charValue());
        } 
        return false;
      case 9:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.floatValue());
          case 8:
            return (constant.doubleValue() == constant.floatValue());
          case 9:
            return true;
          case 10:
            return (constant.intValue() == constant.floatValue());
          case 4:
            return (constant.shortValue() == constant.floatValue());
          case 3:
            return (constant.byteValue() == constant.floatValue());
          case 7:
            return ((float)constant.longValue() == constant.floatValue());
        } 
        return false;
      case 8:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.doubleValue());
          case 8:
            return true;
          case 9:
            return (constant.floatValue() == constant.doubleValue());
          case 10:
            return (constant.intValue() == constant.doubleValue());
          case 4:
            return (constant.shortValue() == constant.doubleValue());
          case 3:
            return (constant.byteValue() == constant.doubleValue());
          case 7:
            return (constant.longValue() == constant.doubleValue());
        } 
        return false;
      case 3:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.byteValue());
          case 8:
            return (constant.doubleValue() == constant.byteValue());
          case 9:
            return (constant.floatValue() == constant.byteValue());
          case 10:
            return (constant.intValue() == constant.byteValue());
          case 4:
            return (constant.shortValue() == constant.byteValue());
          case 3:
            return true;
          case 7:
            return (constant.longValue() == constant.byteValue());
        } 
        return false;
      case 4:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.shortValue());
          case 8:
            return (constant.doubleValue() == constant.shortValue());
          case 9:
            return (constant.floatValue() == constant.shortValue());
          case 10:
            return (constant.intValue() == constant.shortValue());
          case 4:
            return true;
          case 3:
            return (constant.byteValue() == constant.shortValue());
          case 7:
            return (constant.longValue() == constant.shortValue());
        } 
        return false;
      case 10:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.intValue());
          case 8:
            return (constant.doubleValue() == constant.intValue());
          case 9:
            return (constant.floatValue() == constant.intValue());
          case 10:
            return true;
          case 4:
            return (constant.shortValue() == constant.intValue());
          case 3:
            return (constant.byteValue() == constant.intValue());
          case 7:
            return (constant.longValue() == constant.intValue());
        } 
        return false;
      case 7:
        switch (constantTypeID) {
          case 2:
            return (constant.charValue() == constant.longValue());
          case 8:
            return (constant.doubleValue() == constant.longValue());
          case 9:
            return (constant.floatValue() == (float)constant.longValue());
          case 10:
            return (constant.intValue() == constant.longValue());
          case 4:
            return (constant.shortValue() == constant.longValue());
          case 3:
            return (constant.byteValue() == constant.longValue());
          case 7:
            return true;
        } 
        return false;
    } 
    return false;
  }
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo) {
    return flowInfo;
  }
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo, boolean valueRequired) {
    return analyseCode(currentScope, flowContext, flowInfo);
  }
  
  public final boolean checkCastTypesCompatibility(Scope scope, TypeBinding castType, TypeBinding expressionType, org.eclipse.jdt.internal.compiler.ast.Expression expression) {
    TypeBinding castElementType, exprElementType, bound;
    ReferenceBinding referenceBinding;
    TypeBinding typeBinding1;
    ReferenceBinding[] intersectingTypes;
    int i, length;
    if (castType == null || expressionType == null)
      return true; 
    boolean use15specifics = ((scope.compilerOptions()).sourceLevel >= 3211264L);
    boolean use17specifics = ((scope.compilerOptions()).sourceLevel >= 3342336L);
    if (castType.isBaseType()) {
      if (expressionType.isBaseType()) {
        if (TypeBinding.equalsEquals(expressionType, castType)) {
          if (expression != null)
            this.constant = expression.constant; 
          tagAsUnnecessaryCast(scope, castType);
          return true;
        } 
        boolean necessary = false;
        if (expressionType.isCompatibleWith(castType) || (
          necessary = BaseTypeBinding.isNarrowing(castType.id, expressionType.id))) {
          if (expression != null) {
            expression.implicitConversion = (castType.id << 4) + expressionType.id;
            if (expression.constant != Constant.NotAConstant)
              this.constant = expression.constant.castTo(expression.implicitConversion); 
          } 
          if (!necessary)
            tagAsUnnecessaryCast(scope, castType); 
          return true;
        } 
      } else {
        if (use17specifics && castType.isPrimitiveType() && expressionType instanceof ReferenceBinding && 
          !expressionType.isBoxedPrimitiveType() && checkCastTypesCompatibility(scope, scope.boxing(castType), expressionType, expression))
          return true; 
        if (use15specifics && 
          scope.environment().computeBoxingType(expressionType).isCompatibleWith(castType)) {
          tagAsUnnecessaryCast(scope, castType);
          return true;
        } 
      } 
      return false;
    } 
    if (use15specifics && 
      expressionType.isBaseType() && 
      scope.environment().computeBoxingType(expressionType).isCompatibleWith(castType)) {
      tagAsUnnecessaryCast(scope, castType);
      return true;
    } 
    if (castType.isIntersectionType18()) {
      ReferenceBinding[] arrayOfReferenceBinding = castType.getIntersectingTypes();
      for (int j = 0, k = arrayOfReferenceBinding.length; j < k; j++) {
        if (!checkCastTypesCompatibility(scope, (TypeBinding)arrayOfReferenceBinding[j], expressionType, expression))
          return false; 
      } 
      return true;
    } 
    switch (expressionType.kind()) {
      case 132:
        if (expressionType == TypeBinding.NULL) {
          tagAsUnnecessaryCast(scope, castType);
          return true;
        } 
        return false;
      case 68:
        if (TypeBinding.equalsEquals(castType, expressionType)) {
          tagAsUnnecessaryCast(scope, castType);
          return true;
        } 
        switch (castType.kind()) {
          case 68:
            castElementType = ((ArrayBinding)castType).elementsType();
            exprElementType = ((ArrayBinding)expressionType).elementsType();
            if (exprElementType.isBaseType() || castElementType.isBaseType()) {
              if (TypeBinding.equalsEquals(castElementType, exprElementType)) {
                tagAsNeedCheckCast();
                return true;
              } 
              return false;
            } 
            return checkCastTypesCompatibility(scope, castElementType, exprElementType, expression);
          case 4100:
            typeBinding1 = expressionType.findSuperTypeOriginatingFrom(castType);
            if (typeBinding1 == null)
              checkUnsafeCast(scope, castType, expressionType, null, true); 
            return checkCastTypesCompatibility(scope, ((TypeVariableBinding)castType).upperBound(), expressionType, expression);
        } 
        switch (castType.id) {
          case 36:
          case 37:
            tagAsNeedCheckCast();
            return true;
          case 1:
            tagAsUnnecessaryCast(scope, castType);
            return true;
        } 
        return false;
      case 4100:
        match = expressionType.findSuperTypeOriginatingFrom(castType);
        if (match != null)
          return checkUnsafeCast(scope, castType, expressionType, match, false); 
        return checkCastTypesCompatibility(scope, castType, ((TypeVariableBinding)expressionType).upperBound(), expression);
      case 516:
      case 8196:
        match = expressionType.findSuperTypeOriginatingFrom(castType);
        if (match != null)
          return checkUnsafeCast(scope, castType, expressionType, match, false); 
        bound = ((WildcardBinding)expressionType).bound;
        if (bound == null)
          referenceBinding = scope.getJavaLangObject(); 
        return checkCastTypesCompatibility(scope, castType, (TypeBinding)referenceBinding, expression);
      case 32772:
        intersectingTypes = expressionType.getIntersectingTypes();
        for (i = 0, length = intersectingTypes.length; i < length; i++) {
          if (checkCastTypesCompatibility(scope, castType, (TypeBinding)intersectingTypes[i], expression))
            return true; 
        } 
        return false;
    } 
    if (expressionType.isInterface()) {
      switch (castType.kind()) {
        case 68:
          switch (expressionType.id) {
            case 36:
            case 37:
              tagAsNeedCheckCast();
              return true;
          } 
          return false;
        case 4100:
          match = expressionType.findSuperTypeOriginatingFrom(castType);
          if (match == null)
            checkUnsafeCast(scope, castType, expressionType, null, true); 
          return checkCastTypesCompatibility(scope, ((TypeVariableBinding)castType).upperBound(), expressionType, expression);
      } 
      if (castType.isInterface()) {
        ReferenceBinding interfaceType = (ReferenceBinding)expressionType;
        match = interfaceType.findSuperTypeOriginatingFrom(castType);
        if (match != null)
          return checkUnsafeCast(scope, castType, (TypeBinding)interfaceType, match, false); 
        tagAsNeedCheckCast();
        match = castType.findSuperTypeOriginatingFrom((TypeBinding)interfaceType);
        if (match != null)
          return checkUnsafeCast(scope, castType, (TypeBinding)interfaceType, match, true); 
        if (use15specifics) {
          checkUnsafeCast(scope, castType, expressionType, null, true);
          if ((scope.compilerOptions()).complianceLevel < 3342336L) {
            if (interfaceType.hasIncompatibleSuperType((ReferenceBinding)castType))
              return false; 
          } else if (!castType.isRawType() && interfaceType.hasIncompatibleSuperType((ReferenceBinding)castType)) {
            return false;
          } 
        } else {
          MethodBinding[] castTypeMethods = getAllOriginalInheritedMethods((ReferenceBinding)castType);
          MethodBinding[] expressionTypeMethods = getAllOriginalInheritedMethods((ReferenceBinding)expressionType);
          int exprMethodsLength = expressionTypeMethods.length;
          for (int j = 0, castMethodsLength = castTypeMethods.length; j < castMethodsLength; j++) {
            for (int k = 0; k < exprMethodsLength; k++) {
              if (TypeBinding.notEquals((castTypeMethods[j]).returnType, (expressionTypeMethods[k]).returnType) && 
                CharOperation.equals((castTypeMethods[j]).selector, (expressionTypeMethods[k]).selector) && 
                castTypeMethods[j].areParametersEqual(expressionTypeMethods[k]))
                return false; 
            } 
          } 
        } 
        return true;
      } 
      if (castType.id == 1) {
        tagAsUnnecessaryCast(scope, castType);
        return true;
      } 
      tagAsNeedCheckCast();
      match = castType.findSuperTypeOriginatingFrom(expressionType);
      if (match != null)
        return checkUnsafeCast(scope, castType, expressionType, match, true); 
      if (((ReferenceBinding)castType).isFinal())
        return false; 
      if (use15specifics) {
        checkUnsafeCast(scope, castType, expressionType, null, true);
        if ((scope.compilerOptions()).complianceLevel < 3342336L) {
          if (((ReferenceBinding)castType).hasIncompatibleSuperType((ReferenceBinding)expressionType))
            return false; 
        } else if (!castType.isRawType() && ((ReferenceBinding)castType).hasIncompatibleSuperType((ReferenceBinding)expressionType)) {
          return false;
        } 
      } 
      return true;
    } 
    switch (castType.kind()) {
      case 68:
        if (expressionType.id == 1) {
          if (use15specifics)
            checkUnsafeCast(scope, castType, expressionType, expressionType, true); 
          tagAsNeedCheckCast();
          return true;
        } 
        return false;
      case 4100:
        match = expressionType.findSuperTypeOriginatingFrom(castType);
        if (match == null)
          checkUnsafeCast(scope, castType, expressionType, null, true); 
        return checkCastTypesCompatibility(scope, ((TypeVariableBinding)castType).upperBound(), expressionType, expression);
    } 
    if (castType.isInterface()) {
      ReferenceBinding refExprType = (ReferenceBinding)expressionType;
      match = refExprType.findSuperTypeOriginatingFrom(castType);
      if (match != null)
        return checkUnsafeCast(scope, castType, expressionType, match, false); 
      if (refExprType.isFinal())
        return false; 
      tagAsNeedCheckCast();
      match = castType.findSuperTypeOriginatingFrom(expressionType);
      if (match != null)
        return checkUnsafeCast(scope, castType, expressionType, match, true); 
      if (use15specifics) {
        checkUnsafeCast(scope, castType, expressionType, null, true);
        if ((scope.compilerOptions()).complianceLevel < 3342336L) {
          if (refExprType.hasIncompatibleSuperType((ReferenceBinding)castType))
            return false; 
        } else if (!castType.isRawType() && refExprType.hasIncompatibleSuperType((ReferenceBinding)castType)) {
          return false;
        } 
      } 
      return true;
    } 
    TypeBinding match = expressionType.findSuperTypeOriginatingFrom(castType);
    if (match != null) {
      if (expression != null && castType.id == 11)
        this.constant = expression.constant; 
      return checkUnsafeCast(scope, castType, expressionType, match, false);
    } 
    match = castType.findSuperTypeOriginatingFrom(expressionType);
    if (match != null) {
      tagAsNeedCheckCast();
      return checkUnsafeCast(scope, castType, expressionType, match, true);
    } 
    return false;
  }
  
  public boolean checkNPE(BlockScope scope, FlowContext flowContext, FlowInfo flowInfo, int ttlForFieldCheck) {
    boolean isNullable = false;
    if (this.resolvedType != null) {
      if ((this.resolvedType.tagBits & 0x100000000000000L) != 0L)
        return true; 
      if ((this.resolvedType.tagBits & 0x80000000000000L) != 0L)
        isNullable = true; 
    } 
    LocalVariableBinding local = localVariableBinding();
    if (local != null && (
      local.type.tagBits & 0x2L) == 0L) {
      if ((this.bits & 0x20000) == 0) {
        flowContext.recordUsingNullReference((Scope)scope, local, (ASTNode)this, 
            3, flowInfo);
        if (!flowInfo.isDefinitelyNonNull(local))
          flowContext.recordAbruptExit(); 
      } 
      flowInfo.markAsComparedEqualToNonNull(local);
      flowContext.markFinallyNullStatus(local, 4);
      return true;
    } 
    if (isNullable) {
      scope.problemReporter().dereferencingNullableExpression(this);
      return true;
    } 
    return false;
  }
  
  public boolean checkNPE(BlockScope scope, FlowContext flowContext, FlowInfo flowInfo) {
    return checkNPE(scope, flowContext, flowInfo, 0);
  }
  
  protected void checkNPEbyUnboxing(BlockScope scope, FlowContext flowContext, FlowInfo flowInfo) {
    int status;
    if ((this.implicitConversion & 0x400) != 0 && (
      this.bits & 0x20000) == 0 && (
      status = nullStatus(flowInfo, flowContext)) != 4)
      flowContext.recordUnboxing((Scope)scope, this, status, flowInfo); 
  }
  
  public boolean checkUnsafeCast(Scope scope, TypeBinding castType, TypeBinding expressionType, TypeBinding match, boolean isNarrowing) {
    if (TypeBinding.equalsEquals(match, castType)) {
      if (!isNarrowing)
        tagAsUnnecessaryCast(scope, castType); 
      return true;
    } 
    if (match != null && (!castType.isReifiable() || !expressionType.isReifiable()) && (
      isNarrowing ? 
      match.isProvablyDistinct(expressionType) : 
      castType.isProvablyDistinct(match)))
      return false; 
    if (!isNarrowing)
      tagAsUnnecessaryCast(scope, castType); 
    return true;
  }
  
  public void computeConversion(Scope scope, TypeBinding runtimeType, TypeBinding compileTimeType) {
    if (runtimeType == null || compileTimeType == null)
      return; 
    if (this.implicitConversion != 0)
      return; 
    if (runtimeType != TypeBinding.NULL && runtimeType.isBaseType()) {
      if (!compileTimeType.isBaseType()) {
        TypeBinding unboxedType = scope.environment().computeBoxingType(compileTimeType);
        this.implicitConversion = 1024;
        scope.problemReporter().autoboxing(this, compileTimeType, runtimeType);
        compileTimeType = unboxedType;
      } 
    } else {
      if (compileTimeType != TypeBinding.NULL && compileTimeType.isBaseType()) {
        TypeBinding boxedType = scope.environment().computeBoxingType(runtimeType);
        if (TypeBinding.equalsEquals(boxedType, runtimeType))
          boxedType = compileTimeType; 
        if (boxedType.id >= 128)
          boxedType = compileTimeType; 
        this.implicitConversion = 0x200 | (boxedType.id << 4) + compileTimeType.id;
        scope.problemReporter().autoboxing(this, compileTimeType, scope.environment().computeBoxingType(boxedType));
        return;
      } 
      if (this.constant != Constant.NotAConstant && this.constant.typeID() != 11) {
        this.implicitConversion = 512;
        return;
      } 
    } 
    int compileTimeTypeID;
    if ((compileTimeTypeID = compileTimeType.id) >= 128) {
      compileTimeTypeID = ((compileTimeType.erasure()).id == 11) ? 11 : 1;
    } else if (runtimeType.isPrimitiveType() && compileTimeType instanceof ReferenceBinding && !compileTimeType.isBoxedPrimitiveType()) {
      compileTimeTypeID = 1;
    } 
    int runtimeTypeID;
    switch (runtimeTypeID = runtimeType.id) {
      case 2:
      case 3:
      case 4:
        if (compileTimeTypeID == 1) {
          this.implicitConversion |= (runtimeTypeID << 4) + compileTimeTypeID;
          break;
        } 
        this.implicitConversion |= 160 + compileTimeTypeID;
        break;
      case 5:
      case 7:
      case 8:
      case 9:
      case 10:
      case 11:
        this.implicitConversion |= (runtimeTypeID << 4) + compileTimeTypeID;
        break;
    } 
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream) {
    if ((this.bits & Integer.MIN_VALUE) == 0)
      return; 
    generateCode(currentScope, codeStream, false);
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream, boolean valueRequired) {
    if (this.constant != Constant.NotAConstant) {
      int pc = codeStream.position;
      codeStream.generateConstant(this.constant, this.implicitConversion);
      codeStream.recordPositionsFrom(pc, this.sourceStart);
    } else {
      throw new ShouldNotImplement(Messages.ast_missingCode);
    } 
  }
  
  public void generateOptimizedBoolean(BlockScope currentScope, CodeStream codeStream, BranchLabel trueLabel, BranchLabel falseLabel, boolean valueRequired) {
    Constant cst = optimizedBooleanConstant();
    generateCode(currentScope, codeStream, (valueRequired && cst == Constant.NotAConstant));
    if (cst != Constant.NotAConstant && cst.typeID() == 5) {
      int pc = codeStream.position;
      if (cst.booleanValue()) {
        if (valueRequired && 
          falseLabel == null)
          if (trueLabel != null)
            codeStream.goto_(trueLabel);  
      } else if (valueRequired && 
        falseLabel != null) {
        if (trueLabel == null)
          codeStream.goto_(falseLabel); 
      } 
      codeStream.recordPositionsFrom(pc, this.sourceStart);
      return;
    } 
    int position = codeStream.position;
    if (valueRequired)
      if (falseLabel == null) {
        if (trueLabel != null)
          codeStream.ifne(trueLabel); 
      } else if (trueLabel == null) {
        codeStream.ifeq(falseLabel);
      }  
    codeStream.recordPositionsFrom(position, this.sourceEnd);
  }
  
  public void generateOptimizedStringConcatenation(BlockScope blockScope, CodeStream codeStream, int typeID) {
    if (typeID == 11 && this.constant != Constant.NotAConstant && this.constant.stringValue().length() == 0)
      return; 
    generateCode(blockScope, codeStream, true);
    codeStream.invokeStringConcatenationAppendForType(typeID);
  }
  
  public void generateOptimizedStringConcatenationCreation(BlockScope blockScope, CodeStream codeStream, int typeID) {
    codeStream.newStringContatenation();
    codeStream.dup();
    switch (typeID) {
      case 0:
      case 1:
        codeStream.invokeStringConcatenationDefaultConstructor();
        generateCode(blockScope, codeStream, true);
        codeStream.invokeStringConcatenationAppendForType(1);
        return;
      case 11:
      case 12:
        if (this.constant != Constant.NotAConstant) {
          String stringValue = this.constant.stringValue();
          if (stringValue.length() == 0) {
            codeStream.invokeStringConcatenationDefaultConstructor();
            return;
          } 
          codeStream.ldc(stringValue);
          break;
        } 
        generateCode(blockScope, codeStream, true);
        codeStream.invokeStringValueOf(1);
        break;
      default:
        generateCode(blockScope, codeStream, true);
        codeStream.invokeStringValueOf(typeID);
        break;
    } 
    codeStream.invokeStringConcatenationStringConstructor();
  }
  
  private MethodBinding[] getAllOriginalInheritedMethods(ReferenceBinding binding) {
    ArrayList<MethodBinding> collector = new ArrayList<>();
    getAllInheritedMethods0(binding, collector);
    for (int i = 0, len = collector.size(); i < len; i++)
      collector.set(i, ((MethodBinding)collector.get(i)).original()); 
    return collector.<MethodBinding>toArray(new MethodBinding[collector.size()]);
  }
  
  private void getAllInheritedMethods0(ReferenceBinding binding, ArrayList<MethodBinding> collector) {
    if (!binding.isInterface())
      return; 
    MethodBinding[] methodBindings = binding.methods();
    for (int i = 0, max = methodBindings.length; i < max; i++)
      collector.add(methodBindings[i]); 
    ReferenceBinding[] superInterfaces = binding.superInterfaces();
    for (int j = 0, k = superInterfaces.length; j < k; j++)
      getAllInheritedMethods0(superInterfaces[j], collector); 
  }
  
  public static Binding getDirectBinding(org.eclipse.jdt.internal.compiler.ast.Expression someExpression) {
    if ((someExpression.bits & 0x20000000) != 0)
      return null; 
    if (someExpression instanceof SingleNameReference)
      return ((SingleNameReference)someExpression).binding; 
    if (someExpression instanceof FieldReference) {
      FieldReference fieldRef = (FieldReference)someExpression;
      if (fieldRef.receiver.isThis() && !(fieldRef.receiver instanceof org.eclipse.jdt.internal.compiler.ast.QualifiedThisReference))
        return (Binding)fieldRef.binding; 
    } else if (someExpression instanceof Assignment) {
      org.eclipse.jdt.internal.compiler.ast.Expression lhs = ((Assignment)someExpression).lhs;
      if ((lhs.bits & 0x2000) != 0)
        return getDirectBinding(((Assignment)someExpression).lhs); 
      if (someExpression instanceof org.eclipse.jdt.internal.compiler.ast.PrefixExpression)
        return getDirectBinding(((Assignment)someExpression).lhs); 
    } else if (someExpression instanceof QualifiedNameReference) {
      QualifiedNameReference qualifiedNameReference = (QualifiedNameReference)someExpression;
      if (qualifiedNameReference.indexOfFirstFieldBinding != 1 && 
        qualifiedNameReference.otherBindings == null)
        return qualifiedNameReference.binding; 
    } else if (someExpression.isThis()) {
      return (Binding)someExpression.resolvedType;
    } 
    return null;
  }
  
  public boolean isCompactableOperation() {
    return false;
  }
  
  public boolean isConstantValueOfTypeAssignableToType(TypeBinding constantType, TypeBinding targetType) {
    if (this.constant == Constant.NotAConstant)
      return false; 
    if (TypeBinding.equalsEquals(constantType, targetType))
      return true; 
    if (BaseTypeBinding.isWidening(10, constantType.id) && 
      BaseTypeBinding.isNarrowing(targetType.id, 10))
      return isConstantValueRepresentable(this.constant, constantType.id, targetType.id); 
    return false;
  }
  
  public boolean isTypeReference() {
    return false;
  }
  
  public LocalVariableBinding localVariableBinding() {
    return null;
  }
  
  public void markAsNonNull() {
    this.bits |= 0x20000;
  }
  
  public int nullStatus(FlowInfo flowInfo, FlowContext flowContext) {
    return 4;
  }
  
  public Constant optimizedBooleanConstant() {
    return this.constant;
  }
  
  public boolean isPertinentToApplicability(TypeBinding targetType, MethodBinding method) {
    return true;
  }
  
  public TypeBinding postConversionType(Scope scope) {
    BaseTypeBinding baseTypeBinding;
    TypeBinding typeBinding1, convertedType = this.resolvedType;
    int runtimeType = (this.implicitConversion & 0xFF) >> 4;
    switch (runtimeType) {
      case 5:
        baseTypeBinding = TypeBinding.BOOLEAN;
        break;
      case 3:
        baseTypeBinding = TypeBinding.BYTE;
        break;
      case 4:
        baseTypeBinding = TypeBinding.SHORT;
        break;
      case 2:
        baseTypeBinding = TypeBinding.CHAR;
        break;
      case 10:
        baseTypeBinding = TypeBinding.INT;
        break;
      case 9:
        baseTypeBinding = TypeBinding.FLOAT;
        break;
      case 7:
        baseTypeBinding = TypeBinding.LONG;
        break;
      case 8:
        baseTypeBinding = TypeBinding.DOUBLE;
        break;
    } 
    if ((this.implicitConversion & 0x200) != 0)
      typeBinding1 = scope.environment().computeBoxingType((TypeBinding)baseTypeBinding); 
    return typeBinding1;
  }
  
  public StringBuffer print(int indent, StringBuffer output) {
    printIndent(indent, output);
    return printExpression(indent, output);
  }
  
  public abstract StringBuffer printExpression(int paramInt, StringBuffer paramStringBuffer);
  
  public StringBuffer printStatement(int indent, StringBuffer output) {
    return print(indent, output).append(";");
  }
  
  public void resolve(BlockScope scope) {
    resolveType(scope);
  }
  
  public TypeBinding resolveType(BlockScope scope) {
    return null;
  }
  
  public TypeBinding resolveType(ClassScope scope) {
    return null;
  }
  
  public TypeBinding resolveTypeExpecting(BlockScope scope, TypeBinding expectedType) {
    setExpectedType(expectedType);
    TypeBinding expressionType = resolveType(scope);
    if (expressionType == null)
      return null; 
    if (TypeBinding.equalsEquals(expressionType, expectedType))
      return expressionType; 
    if (!expressionType.isCompatibleWith(expectedType))
      if (scope.isBoxingCompatibleWith(expressionType, expectedType)) {
        computeConversion((Scope)scope, expectedType, expressionType);
      } else {
        scope.problemReporter().typeMismatchError(expressionType, expectedType, (ASTNode)this, null);
        return null;
      }  
    return expressionType;
  }
  
  public org.eclipse.jdt.internal.compiler.ast.Expression resolveExpressionExpecting(TypeBinding targetType, Scope scope, InferenceContext18 context) {
    return this;
  }
  
  public boolean forcedToBeRaw(ReferenceContext referenceContext) {
    if (this instanceof NameReference) {
      Binding receiverBinding = ((NameReference)this).binding;
      if (receiverBinding.isParameter() && (((LocalVariableBinding)receiverBinding).tagBits & 0x200L) != 0L)
        return true; 
      if (receiverBinding instanceof FieldBinding) {
        FieldBinding field = (FieldBinding)receiverBinding;
        if (field.type.isRawType())
          if (referenceContext instanceof AbstractMethodDeclaration) {
            AbstractMethodDeclaration methodDecl = (AbstractMethodDeclaration)referenceContext;
            if (TypeBinding.notEquals((TypeBinding)field.declaringClass, (TypeBinding)methodDecl.binding.declaringClass))
              return true; 
          } else if (referenceContext instanceof TypeDeclaration) {
            TypeDeclaration type = (TypeDeclaration)referenceContext;
            if (TypeBinding.notEquals((TypeBinding)field.declaringClass, (TypeBinding)type.binding))
              return true; 
          }  
      } 
    } else if (this instanceof MessageSend) {
      if (!CharOperation.equals(((MessageSend)this).binding.declaringClass.getFileName(), 
          referenceContext.compilationResult().getFileName()))
        return true; 
    } else if (this instanceof FieldReference) {
      FieldBinding field = ((FieldReference)this).binding;
      if (!CharOperation.equals(field.declaringClass.getFileName(), 
          referenceContext.compilationResult().getFileName()))
        return true; 
      if (field.type.isRawType())
        if (referenceContext instanceof AbstractMethodDeclaration) {
          AbstractMethodDeclaration methodDecl = (AbstractMethodDeclaration)referenceContext;
          if (TypeBinding.notEquals((TypeBinding)field.declaringClass, (TypeBinding)methodDecl.binding.declaringClass))
            return true; 
        } else if (referenceContext instanceof TypeDeclaration) {
          TypeDeclaration type = (TypeDeclaration)referenceContext;
          if (TypeBinding.notEquals((TypeBinding)field.declaringClass, (TypeBinding)type.binding))
            return true; 
        }  
    } else if (this instanceof ConditionalExpression) {
      ConditionalExpression ternary = (ConditionalExpression)this;
      if (ternary.valueIfTrue.forcedToBeRaw(referenceContext) || ternary.valueIfFalse.forcedToBeRaw(referenceContext))
        return true; 
    } 
    return false;
  }
  
  public Object reusableJSRTarget() {
    if (this.constant != Constant.NotAConstant && (this.implicitConversion & 0x200) == 0)
      return this.constant; 
    return null;
  }
  
  public void setExpectedType(TypeBinding expectedType) {}
  
  public void setExpressionContext(ExpressionContext context) {}
  
  public boolean isCompatibleWith(TypeBinding left, Scope scope) {
    return (this.resolvedType != null && this.resolvedType.isCompatibleWith(left, scope));
  }
  
  public boolean isBoxingCompatibleWith(TypeBinding left, Scope scope) {
    return (this.resolvedType != null && isBoxingCompatible(this.resolvedType, left, this, scope));
  }
  
  public boolean sIsMoreSpecific(TypeBinding s, TypeBinding t, Scope scope) {
    return s.isCompatibleWith(t, scope);
  }
  
  public boolean isExactMethodReference() {
    return false;
  }
  
  public boolean isPolyExpression() throws UnsupportedOperationException {
    return false;
  }
  
  public boolean isPolyExpression(MethodBinding method) {
    return false;
  }
  
  public void tagAsNeedCheckCast() {}
  
  public void tagAsUnnecessaryCast(Scope scope, TypeBinding castType) {}
  
  public org.eclipse.jdt.internal.compiler.ast.Expression toTypeReference() {
    return this;
  }
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {}
  
  public void traverse(ASTVisitor visitor, ClassScope scope) {}
  
  public boolean statementExpression() {
    return false;
  }
  
  public VariableBinding nullAnnotatedVariableBinding(boolean supportTypeAnnotations) {
    return null;
  }
  
  public boolean isFunctionalType() {
    return false;
  }
  
  public org.eclipse.jdt.internal.compiler.ast.Expression[] getPolyExpressions() {
    (new org.eclipse.jdt.internal.compiler.ast.Expression[1])[0] = this;
    return isPolyExpression() ? new org.eclipse.jdt.internal.compiler.ast.Expression[1] : NO_EXPRESSIONS;
  }
  
  public boolean isPotentiallyCompatibleWith(TypeBinding targetType, Scope scope) {
    return isCompatibleWith(targetType, scope);
  }
}
